#include "burnint.h"


/*

// now in the same order as mame, hopefully.
struct GraphicsDecodeInfo {
unsigned long width; // number of pixels across the x axis
unsigned long height; // number of pixels down the y axis
unsigned long elementCount; // number of graphic elements to decode
unsigned long bitplanes; // bitplane count

unsigned long bitplane_offsets[max_bitplane_count]; // bitplane offsets
unsigned long xbits_offsets[max_x_y_size]; // x offset layout
unsigned long ybits_offsets[max_x_y_size]; // y offset layout

unsigned long bits_per_element;  // each elment takes this number of bits
};

*/

INLINE int readbit(const UINT8 *src, int bitnum)
{
	return src[bitnum / 8] & (0x80 >> (bitnum % 8));
}


void GraphicsDecode(GraphicsDecodeInfo *graphicsInfo, unsigned char *dest, unsigned char *source)
{
	int plane, x, y;

	for (unsigned long tilecount = 0; tilecount < graphicsInfo->elementCount; tilecount++)
	{

		const unsigned long *xoffset = graphicsInfo->xbits_offsets;
		const unsigned long *yoffset = graphicsInfo->ybits_offsets;
		int lineModulo = graphicsInfo->width;
		int charModulo = graphicsInfo->height * lineModulo;
		unsigned char *dp = dest + (tilecount * charModulo);
		memset(dp, 0, charModulo);


		for (plane = 0; plane < graphicsInfo->bitplanes; plane++)
		{
			int planebit = 1 << (graphicsInfo->bitplanes - 1 - plane);
			int planeoffs = tilecount * graphicsInfo->bits_per_element + graphicsInfo->bitplane_offsets[plane];

			for (y = 0; y < graphicsInfo->height; y++)
			{
				int yoffs = planeoffs + yoffset[y];

				dp = dest + tilecount * charModulo + y * lineModulo;
				for (x = 0; x < graphicsInfo->width; x++)
				{
					if (readbit(source, yoffs + xoffset[x]))
					{
						dp[x] |= planebit;
					}
				}
			}
		}
	}
}


// same as about but override the element count
void GraphicsDecode(GraphicsDecodeInfoRGNFRAC *graphicsInfo, unsigned char *dest, unsigned char *source, unsigned long countOverride)
{

	//  The current bit plane.
	unsigned long bCurPlane;

	//  The current pixel row and column in the destination buffer.
	unsigned long dwCurRow;
	unsigned long dwCurCol;

	//  The source bit of interest.
	unsigned long dwSourceBit;

	//  The value of the current pixel in the bitmap.
	unsigned long dwValue;


	for (unsigned long tilecount = 0;tilecount< countOverride; tilecount++)
	{
		//  The offset.
		unsigned long dwOffset = tilecount * graphicsInfo->bits_per_element;

		//  Loop through each row and column of the graphic.
		for( dwCurRow = 0 ; dwCurRow < graphicsInfo->height ; ++dwCurRow )
		{
			for( dwCurCol = 0 ; dwCurCol < graphicsInfo->width ; ++dwCurCol )
			{
				//  Initialize the value.
				dwValue = 0;

				//  Loop through each bit plane for the character.
				for( bCurPlane = 0 ; bCurPlane < graphicsInfo->bitplanes ; ++bCurPlane )
				{
					//  Shift the value to make room for the new plane.
					dwValue <<= 1;

					//  Calculate the source bit.
					dwSourceBit = dwOffset + (graphicsInfo->bitplane_order[ bCurPlane ] * (graphicsInfo->bits_per_element * countOverride)) + graphicsInfo->ybits_offsets[ dwCurRow ] +  graphicsInfo->xbits_offsets[ dwCurCol ];

					//  Add the bit from the current bit plane to the 
					//  destination byte.
					dwValue |= ( source[ dwSourceBit >> 3 ] >> (7 - ( dwSourceBit & 7 ))) & 0x01;
					//  Set the pixel value in the bitmap.
					dest[(graphicsInfo->bits_per_element*tilecount)+dwCurCol+(dwCurRow*graphicsInfo->height)]= dwValue ;
				}
			}
		}

	}
}

