#define max_x_y_size 32
#define max_bitplane_count 8

#define RGN_FRAC(num,den) (0x80000000 | (((num) & 0x0f) << 27) | (((den) & 0x0f) << 23))

// now in the same order as mame, hopefully.
struct GraphicsDecodeInfo {
	unsigned long width; // number of pixels across the x axis
	unsigned long height; // number of pixels down the y axis
	unsigned long elementCount; // number of graphic elements to decode
	unsigned long bitplanes; // bitplane count

	unsigned long bitplane_offsets[max_bitplane_count]; // bitplane offsets
	unsigned long xbits_offsets[max_x_y_size]; // x offset layout
	unsigned long ybits_offsets[max_x_y_size]; // y offset layout

	unsigned long bits_per_element;  // each elment takes this number of bits
};


// now in the same order as mame, hopefully.
struct GraphicsDecodeInfoRGNFRAC {
	unsigned long width; // number of pixels across the x axis
	unsigned long height; // number of pixels down the y axis

	unsigned long bitplanes; // bitplane count

	unsigned long bitplane_order[max_bitplane_count]; // bitplane offsets
	unsigned long xbits_offsets[max_x_y_size]; // x offset layout
	unsigned long ybits_offsets[max_x_y_size]; // y offset layout

	unsigned long bits_per_element;  // each elment takes this number of bits
};


void GraphicsDecode(GraphicsDecodeInfo *graphicsInfo, unsigned char *dest, unsigned char *source);
void GraphicsDecode(GraphicsDecodeInfoRGNFRAC *graphicsInfo, unsigned char *dest, unsigned char *source, unsigned long countOverride);